import { Component, OnInit, Output, EventEmitter } from '@angular/core';
import {
  StickerInfo,
  StickerFilesInfo,
  StickerUtil
} from '@ucap-webmessenger/core';

@Component({
  selector: 'ucap-sticker-selector',
  templateUrl: './sticker-selector.component.html',
  styleUrls: ['./sticker-selector.component.scss']
})
export class StickerSelectorComponent implements OnInit {
  @Output()
  selectedSticker = new EventEmitter<StickerFilesInfo>();

  stickerBasePath = 'assets/sticker/';
  stickerInfoList: StickerInfo[] = [];
  stickerFileInfoList: StickerFilesInfo[] = [];
  currentSticker: StickerFilesInfo;

  currentTabIndex: number;

  constructor() {}

  ngOnInit() {
    this.stickerInfoList = StickerUtil.getStickerInfoList();
    this.currentTabIndex = 0;
  }

  onSelectedIndexChange(value: number) {
    this.currentTabIndex = value;
  }

  getStickerTitleImage(
    stickerInfo: StickerInfo,
    hover: boolean,
    tabIndex: number
  ) {
    if (this.currentTabIndex === tabIndex) {
      return this.stickerBasePath + stickerInfo.iconPathOn;
    }

    if (!hover) {
      return this.stickerBasePath + stickerInfo.iconPath;
    } else {
      return this.stickerBasePath + stickerInfo.iconPathOn;
    }
  }

  getStickerContentsImage(sticker: StickerFilesInfo) {
    return this.stickerBasePath + sticker.path;
  }

  onClickSelectSticker(sticker: StickerFilesInfo) {
    this.currentSticker = sticker;
    this.selectedSticker.emit(sticker);
  }
}
